#import "KeyPress.h"
#import "Controller.h"

@implementation KeyPress

- (id)initWithFrame:(NSRect)frameRect
{
	[super initWithFrame:frameRect];
  inputType = ascii;
  temporaryHexString = [[NSMutableString stringWithCapacity:16] retain];
	return self;
}

-(void)dealloc{
  [temporaryHexString release];
  [super dealloc];
}
- (void)drawRect:(NSRect)rect
{
}

- (BOOL) acceptsFirstResponder{
  return YES;
}

- (void) keyDown:(NSEvent *)event{
  [self translateInput:[event characters]];
}

- (void) translateInput:(NSString *)theString{
  static unichar y = 0;
  unichar x;
  unichar tinkerString[1];
  int i;
  if (inputType == ascii){																//ascii keypress
    [controller keyPressed:theString];
  }
  else{
    for (i = 0; i < [theString length]; i++){
      flipflop = !flipflop;																// hex character must first converted to ascii
      x = [[theString uppercaseString] characterAtIndex:i];
      if (x >= '0' && x <= '9')
        x = x - 48;
      else
        x = x - 55;
      if (x > 15)
        x = 15;
      if (flipflop){
        y = x * 16;    
      }
      else{
        y += x;
        tinkerString[0] = y;
          {[temporaryHexString appendString:[NSString stringWithCharacters:tinkerString length:1]];} 
      }
    }
    if (!flipflop){
      [controller keyPressed:temporaryHexString];
      [temporaryHexString setString:@""];
    }
  }
}
-(IBAction) switchAsciiHex:(BOOL)value{  
  inputType = value;
  flipflop = 0;
}
-(BOOL) AsciiHex{
  return inputType;
}
@end
